/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.ArrayList;

/**
 * クライアントセッションを管理
 * @author tondol
 */
public class ClientManager {
    private Socket              socket = null;
    private BufferedReader      reader = null;
    private PrintWriter         writer = null;
    String host   = null;
    int    listen = 0;
    
    /**
     * サーバーに接続
     */
    public ClientManager() throws Exception {
        socket = new Socket(MainApp.option.host, MainApp.option.port);
        // 文字コードの設定
        reader = new BufferedReader(new InputStreamReader(
                socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintWriter(new OutputStreamWriter(
                socket.getOutputStream(), "Shift_JIS"));
        // サーバーから見たホスト名を取得
        host   = reader.readLine();
        listen = MainApp.option.listen;
    }
    
    /**
     * サーバーから切断
     */
    public void close() throws Exception {
        if (writer != null) writer.close();
        if (socket != null) socket.close();
    }
    
    /**
     * テキストの送受信
     */
    public String recvMessage() throws Exception {
        return reader.readLine();
    }
    
    public void sendMessage(String msg) {
        writer.println(msg);
        writer.flush();
    }
    
    /**
     * アイテムの操作
     */
    public void addItem(FileItem item) throws Exception {
        sendMessage("ADD " + item);
        MainApp.window.putMessage(recvMessage());
    }
    
    public void delItem(FileItem item) throws Exception {
        sendMessage("DEL " + item);
        MainApp.window.putMessage(recvMessage());
    }
    
    /**
     * 検索を実行
     */
    public void search(String word) throws Exception {
        // 検索要求を送信
        sendMessage("LS " + word);
        // 検索結果を受信
        ArrayList<FileItem> output = new ArrayList<FileItem>();
        int size = Integer.parseInt(recvMessage());
        for (int i=0;i<size;i++) {
            String line = recvMessage();
            output.add(new FileItem(line));
        }
        // 表に反映
        MainApp.window.modelSearch.setItems(output);
    }
}
