/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.*;
import java.security.MessageDigest;

/**
 * ファイル情報を表すクラス
 * @author tondol
 */
public class FileItem {
    String name, hash, host;
    long size; int port;
    
    /**
     * <File>からアイテムを生成
     */
    public FileItem(File file) {
        name = file.getName();
        size = file.length();
        hash = getDigest(file);
        host = MainApp.client.host;
        port = MainApp.client.listen;
    }
    
    /**
     * <String>からアイテムを生成
     */
    public FileItem(String line) {
        String[] array = line.split("//", 5);
        name = array[0];
        size = Long.parseLong(array[1]);
        hash = array[2];
        host = array[3];
        port = Integer.parseInt(array[4]);
    }
    
    /**
     * <File>からハッシュを生成
     */
    private String getDigest(File file) {
        // いろいろ準備
        FileInputStream ifstream = null;
        MessageDigest   digest   = null;
        byte buf[] = new byte[65536];
        long remain = file.length();
        // ブロックごとにダイジェストを更新
        try {
            ifstream = new FileInputStream(file.getPath());
            digest   = MessageDigest.getInstance("MD5");
            while (remain > 0) {
                long tmp = ifstream.read(buf, 0, 65536);
                if (tmp < 0) break;
                remain -= tmp;
                digest.update(buf);
            }
        } catch(Exception e) {
        } finally {
            try {
                if (ifstream != null) ifstream.close();
            } catch(IOException e) {
            }
        }
        // 文字列表現を取得
        buf = digest.digest();
        StringBuffer strbuf = new StringBuffer();
        for (int i=0;i<buf.length;i++) {
            String str = Integer.toHexString(buf[i] & 0xff);
            if (str.length() == 1) strbuf.append("0");
            strbuf.append(str);
        }
        return strbuf.toString();
    }

    /**
     * 中身を考慮した一致判定
     */
    @Override public boolean equals(Object obj) {
        if (obj == null)  return false;
        if (getClass() != obj.getClass()) return false;
        final FileItem other = (FileItem) obj;
        if (!this.hash.equals(other.hash)) return false;
        return true;
    }

    @Override public int hashCode() {
        int code = 3;
        code = 23 * code + (this.hash != null ? this.hash.hashCode() : 0);
        return code;
    }
    
    /**
     * <String>に変換
     */
    @Override public String toString() {
        return name + "//" + size + "//" +
               hash + "//" + host + "//" + port;
    }
}
