/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 * ファイル情報をJTableで使うためのモデル
 * @author tondol
 */
public class FileTableModel extends AbstractTableModel {
    ArrayList<FileItem> items = null;

    public FileTableModel() {
        super();
        items = new ArrayList<FileItem>();
    }
    
    /**
     * アイテム操作
     */
    public FileItem getItem(int index) {
        return items.get(index);
    }
    
    public void setItems(ArrayList<FileItem> items) {
        this.items = items;
        fireTableDataChanged();
    }
    
    public void clearItem() {
        items.clear();
        fireTableDataChanged();
    }
    
    /**
     * 表のインターフェイス
     */
    public int getRowCount() {
        return items.size();
    }

    public int getColumnCount() {
        return 3;
    }
    
    @Override public String getColumnName(int column) {
        String values[] = { "ファイル名", "サイズ", "ハッシュ" };
        return values[column];
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        if (rowIndex >= items.size()) return null;
        switch (columnIndex) {
            case 0: return items.get(rowIndex).name;
            case 1: return items.get(rowIndex).size;
            case 2: return items.get(rowIndex).hash;
            default: return null;
        }
    }
}
